# Define if you want to build the sane backend (default)
%define sane_backend		1
%{?_with_sane:			%global sane_backend 1}
%{?_without_sane:		%global sane_backend 0}

%define ptal_major		0
%define ptal_libname		%mklibname ptal %{ptal_major}

%define hpojip_major		0
%define hpojip_libname		%mklibname hpojip %{hpojip_major}

%define sane_hpoj_major		1
%define sane_hpoj_libname	%mklibname sane-hpoj %{sane_hpoj_major}

# Suppress automatically generated Requires for devel packages
%define _requires_exceptions devel\(.*\)

##### GENERAL STUFF #####

Summary:	HP OfficeJet low level driver infrastructure
Name:		hpoj
Version:	0.91
Release:	6mdk
License:	GPL
Group:		System/Servers


##### SOURCE FILES #####

Source: http://cesnet.dl.sourceforge.net/sourceforge/hpoj/%{name}-%{version}.tar.bz2
#Source: http://hpoj.sourceforge.net/download/hpoj-0.90-20030803.tar.bz2
# Icon for the Mandrake menu
Source3: hpoj.png.bz2
# Wrapper script to start "xojpanel" with device auto-detection
Source6: allxojpanels.bz2
Patch0: hpoj-ppc.patch.bz2

# lib64 fixes
Patch4: hpoj-lib64.patch.bz2

Patch5: hpoj-0.90-split-the-glob-with-spaces-to-please-perl-base.patch.bz2

# Adaptation to kernel 2.6.x
Patch6: hpoj-0.91-kernel26.patch.bz2

##### ADDITIONAL DEFINITIONS #####

Url: http://hpoj.sourceforge.net
#Requires: %{ptal_libname} %{hpojip_libname} libsnmp0 libusb0.1_4
%if %{sane_backend}
BuildRequires: libsane-devel
%endif
BuildRequires:	libusb-devel
BuildRequires:	net-snmp-devel
BuildRequires:	libqt-devel
Prereq:		rpm-helper
BuildRoot: %{_tmppath}/%{name}-buildroot
Conflicts: cups <= 1.1.14

%description

This is an HP-sponsored project to add Linux support for most
Hewlett-Packard OfficeJet, PSC, and LaserJet all-in-one peripherals
(also known as Multi-Function Peripherals or MFPs), which can print,
scan, copy, and (on some models) fax.

It is work in progress, but printing and scanning are supported on
most models, when either connected to the parallel port or USB on a
Linux (Intel or Alpha) workstation, or to a LAN with selected HP
JetDirect print servers.


##### SUB-PACKAGES #####

%package -n %{ptal_libname}
Summary: Dynamic library for the "hpoj" HP Officejet low level drivers
Group: System/Servers

%description -n %{ptal_libname}
Library needed for the "hpoj" HP Officejet low level drivers.

%package -n %{ptal_libname}-devel
Summary: Headers and links to compile against the "%{ptal_libname}" ("hpoj") library
Group: Development/C
Requires: %{ptal_libname} >= %{version}-%{release}
Provides: libptal-devel = %{version}-%{release}
Requires: net-snmp-devel
Requires: openssl-devel

%description -n %{ptal_libname}-devel
This package contains all files which one needs to compile programs using
the "%{ptal_libname}" library.

%package -n %{hpojip_libname}
Summary: Dynamic library for the "hpoj" HP Officejet low level drivers
Group: System/Servers

%description -n %{hpojip_libname}
Library needed for the "hpoj" HP Officejet low level drivers.

%package -n %{hpojip_libname}-devel
Summary: Headers and links to compile against the "%{hpojip_libname}" ("hpoj") library
Group: Development/C
Requires: %{hpojip_libname} >= %{version}-%{release}
Provides: libhpojip-devel = %{version}-%{release}

%description -n %{hpojip_libname}-devel
This package contains all files which one needs to compile programs using
the "%{hpojip_libname}" library.

%if %{sane_backend}
%package -n %{sane_hpoj_libname}
Summary: SANE driver for scanners in HP's multi-function devices (from HPOJ)
Group: System/Servers
Requires: sane-backends
%define _requires_exceptions devel(libcrypto)\\|devel(libdl)\\|devel(libhpojip)\\|devel(libm)\\|devel(libptal)\\|devel(libsnmp)
%endif

%if %{sane_backend}
%description -n %{sane_hpoj_libname}
SANE driver for scanners in HP's multi-function devices (from HPOJ)
%endif

%package -n xojpanel
Summary: Graphical tool displaying the contents of the LCD of HP printers
Group: System/Servers
#Requires: %{ptal_libname} libqt3
Conflicts: hpoj < 0.9-0.3mdk

%description -n xojpanel
Graphical tool displaying the contents of the LCD of HP multi-function
devices and laser printers. Very useful to monitor the state (paper, ink,
running job) of a printer directly on one's workstation's screen.

##### PREP #####

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}
#rm -rf $RPM_BUILD_DIR/%{name}
%setup -q -n %{name}-%{version}
#setup -q -n %{name}
#setup -q -n hpoj-0.90-20030803

%ifarch ppc
%patch0 -p1
%endif

%patch4 -p1 -b .lib64
#patch5 -p1
%patch6 -p0

# needed by Patch4
autoconf

# Load menu icon
bzcat %{SOURCE3} > hpoj.png
# Load "xojpanel" wrapper script
bzcat %{SOURCE6} > allxojpanels

##### BUILD #####

%build
%serverbuild

# Fix hard-coded paths, also take into account paths mentioned in the docs
for i in `find . -type f -print`; do
    perl -p -i -e "s!doc/hpoj!doc/%{name}-%{version}!" $i
done
# Only needed for CVS snapshots
autoconf

%if !%{sane_backend}
WITHOUT_SANE="--without-sane"
%endif
%configure2_5x --with-qt=/usr/lib/qt3 --enable-mt --with-snmp=/usr/include/net-snmp/ucd-snmp/ $WITHOUT_SANE
#--sysconfdir=/etc 

# Do not use the macro, it has parallelizing problems
make	etcdir=%{_sysconfdir} docdir=%{_docdir}/%{name}-%{version}

##### INSTALL #####

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_initrddir}

%makeinstall etcdir=%{buildroot}%{_sysconfdir}

# install menu icon
mkdir -p $RPM_BUILD_ROOT%{_iconsdir}/locolor/16x16/apps/
install -m 644 hpoj.png $RPM_BUILD_ROOT%{_iconsdir}/locolor/16x16/apps/

# install menu entry
mkdir -p $RPM_BUILD_ROOT%{_menudir}

cat <<EOF > $RPM_BUILD_ROOT%{_menudir}/xojpanel
?package(xojpanel): needs=X11 \
section=Applications/Monitoring \
title="X Office Jet Panel" \
longtitle="Displays the contents of the front panel LCD screen of your HP Office Jet in a window on your desktop" \
command="%{_bindir}/allxojpanels" \
icon="%{_iconsdir}/locolor/16x16/apps/hpoj.png"
EOF

# Install "xojpanel" wrapper
install -m 755 allxojpanels $RPM_BUILD_ROOT%{_bindir}

# Set priority in startup file for HPOJ to get started before CUPS
perl -p -i -e 's/chkconfig: 2345 59 61/chkconfig: 2345 14 61/' %{buildroot}%{_sbindir}/ptal-init

# Install startup script
#install -m 755 hpoj.startup $RPM_BUILD_ROOT%{_initrddir}/hpoj
#mv %{buildroot}%{_sbindir}/ptal-init %{buildroot}%{_initrddir}/hpoj
ln -sf %{_sbindir}/ptal-init %{buildroot}%{_initrddir}/hpoj

# Directories where the daemon will create device nodes
install -d %{buildroot}/dev/ptal-mlcd
install -d %{buildroot}/dev/ptal-printd

# Backend filter for CUPS
install -d %{buildroot}%{_libdir}/cups/backend
ln -sf %{_sbindir}/ptal-cups %{buildroot}%{_libdir}/cups/backend/ptal

# Make SANE scanner driver modules available in the right place (SANE
# only finds them in /usr/lib/sane, not in /usr/lib
%if %{sane_backend}
install -d %{buildroot}%{_libdir}/sane
(cd %{buildroot}%{_libdir}/sane/ && ln -sf ../libsane-* .)
%else
rm -rf %{buildroot}/%{_libdir}/libsane-hpoj.so*
%endif

##### PRE/POST INSTALL SCRIPTS #####

%post
# Let HPOJ daemon be automatically started at boot time
%_post_service hpoj

%post -n %{ptal_libname} -p /sbin/ldconfig

%post -n %{hpojip_libname} -p /sbin/ldconfig

%if %{sane_backend}
%post -n %{sane_hpoj_libname}
/sbin/ldconfig
# Add HPOJ driver to /etc/sane.d/dll.conf
if ! grep ^hpoj /etc/sane.d/dll.conf >/dev/null 2>/dev/null ; then \
	echo hpoj >> /etc/sane.d/dll.conf; \
fi
%endif

%post -n xojpanel
# menu
%{update_menus}

%preun
# Let HPOJ daemon not be automatically started at boot time any more
%_preun_service hpoj

%if %{sane_backend}
%preun -n %{sane_hpoj_libname}
# Remove HPOJ driver from /etc/sane.d/dll.conf
if [ "$1" = 0 ]; then \
	if grep ^hpoj /etc/sane.d/dll.conf >/dev/null 2>/dev/null ; then \
		sed '/hpoj/d' /etc/sane.d/dll.conf > /tmp/$$; \
		cp -f /tmp/$$ /etc/sane.d/dll.conf; \
		rm -f /tmp/$$; \
	fi; \
fi
%endif

%postun -n %{ptal_libname} -p /sbin/ldconfig

%postun -n %{hpojip_libname} -p /sbin/ldconfig

%if %{sane_backend}
%postun -n %{sane_hpoj_libname} -p /sbin/ldconfig
%endif

%postun -n xojpanel
## menu
%{update_menus}

##### CLEAN UP #####

%clean
rm -rf $RPM_BUILD_ROOT


##### FILE LISTS FOR ALL BINARY PACKAGES #####

##### hpoj
%files
%defattr(-,root,root)
#config(noreplace) %{_sysconfdir}/ptal*
%config(noreplace) %{_initrddir}/*
%{_sbindir}/*
%{_bindir}/ptal*
%{_bindir}/hpojip-test
%doc %{_defaultdocdir}/%{name}-%{version}
%dir /dev/ptal-mlcd
%dir /dev/ptal-printd
# CUPS backend
%{_libdir}/cups/backend/ptal

##### %{ptal_libname}
%files -n %{ptal_libname}
%defattr(-,root,root)
%{_libdir}/libptal*.so.*

##### %{ptal_libname}-devel
%files -n %{ptal_libname}-devel
%defattr(-,root,root)
%{_includedir}/ptal*
%{_libdir}/libptal*.so

##### %{hpojip_libname}
%files -n %{hpojip_libname}
%defattr(-,root,root)
%{_libdir}/libhpojip*.so.*

##### %{hpojip_libname}-devel
%files -n %{hpojip_libname}-devel
%defattr(-,root,root)
%{_includedir}/hpojip*
%{_libdir}/libhpojip*.so

##### %{sane_hpoj_libname}
%if %{sane_backend}
%files -n %{sane_hpoj_libname}
%defattr(-,root,root)
%{_libdir}/libsane-hpoj*.so*
%{_libdir}/sane/libsane-hpoj*.so*
%endif

##### xojpanel
%files -n xojpanel
%defattr(-,root,root)
%{_bindir}/xojpanel
%{_bindir}/allxojpanels
# menu entry
%{_iconsdir}/locolor/16x16/apps/*
%{_menudir}/*


##### CHANGELOG #####

%changelog
* Thu Feb 10 2005 Till Kamppeter <till@mandrakesoft.com> 0.91-6mdk
- Correct priority in startup script so that the daemons get started
  before CUPS.

* Fri Jun 11 2004 Till Kamppeter <till@mandrakesoft.com> 0.91-5mdk
- Rebuilt.

* Wed Feb 25 2004 Till Kamppeter <till@mandrakesoft.com> 0.91-4mdk
- Fix on the patch for kernel 2.6.x.

* Fri Feb 13 2004 Till Kamppeter <till@mandrakesoft.com> 0.91-3mdk
- Made the ptal-init script compatible to both kernel 2.4.x and 2.6.x.

* Tue Dec 16 2003 Frederic Lepied <flepied@mandrakesoft.com> 0.91-2mdk
- corrected _requires_exceptions to have the correct dependencies

* Wed Dec 10 2003 Till Kamppeter <till@mandrakesoft.com> 0.91-1mdk
- Updated to version 0.91.
- Suppressed automatically generated Requires for devel packages.

* Mon Dec 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.90-10mdk
- filter out insanity for %%{sane_hpoj_libname} (it needs dl()?)
- fix some rpmlint errors

* Sun Nov 16 2003 Stefan van der Eijk <stefan@eijk.nu> 0.90-9mdk
- BuildRequires
- remove libsane-hpoj.so* when building without sane support
- added "--with sane" (default) and "--without sane" switch

* Fri Sep  5 2003 Till Kamppeter <till@mandrakesoft.com> 0.90-8mdk
- Compiled against libnet-snmp instead of libsnmp.

* Tue Sep  2 2003 Till Kamppeter <till@mandrakesoft.com> 0.90-7mdk
- Corrected BuildRequires: no major numbers for libraries (needed to build 
  on 64-bit systems).
- Used the mklibname macro.

* Sun Aug  3 2003 Till Kamppeter <till@mandrakesoft.com> 0.90-6mdk
- Updated to current CVS (USB device access through libusb to give support
  to the HP PSC 1xxx series and OfficeJet 4xxx series and for SMP systems).
- Corrected major number of the libsane-hpoj library.

* Thu Jul 17 2003 David BAUDENS <baudens@mandrakesoft.com> 0.90-5mdk
- Rebuild

* Tue Nov 26 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.90-4mdk
- Fix build

* Sat Aug 10 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-3mdk
- Rebuilt with gcc-3.2-0.3mdk.

* Sat Aug 10 2002 Pixel <pixel@mandrakesoft.com> 0.90-2mdk
- fix glob with spaces to please perl-base (especially for DrakX)

* Thu Aug  8 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-1mdk
- Updated to HPOJ 0.9 final.

* Wed Aug  7 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-0.12mdk
- BuildRequires: libopenssl-devel

* Wed Aug  7 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-0.11mdk
- The "xojpanel" package conflicts with older "hpoj" package versions, added
  appropriate "Conflicts:" entry.

* Mon Aug  5 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-0.10mdk
- Updated to current CVS (lock file name fix and documentation fixes).

* Mon Jul 29 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.90-0.9mdk
- Patch4: lib64 fixes in libraries lookup
- Let it build without SANE circularae dependency

* Sat Jul 27 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-0.8mdk
- Updated to current CVS (Fixed xscanimage segfaulting when clicking
  on the preview area).

* Wed Jul 24 2002 Till Kamppeter <till@mandrakesoft.com> 0.90-0.7mdk
- Updated to current CVS (2nd release candidate for HPOJ 0.90).
- Corrected version number to 0.90.

* Mon Jul 22 2002 Till Kamppeter <till@mandrakesoft.com> 0.9-0.6mdk
- Updated to current CVS (1st release candidate for HPOJ 0.90).

* Thu Jun 27 2002 Till Kamppeter <till@mandrakesoft.com> 0.9-0.5mdk
- Updated to current CVS (last CVS broke printing after one or two 
  printouts).

* Mon Jun 24 2002 Till Kamppeter <till@mandrakesoft.com> 0.9-0.4mdk
- Moved menu updating in %%post and %%postun from main package to "xojpanel"
  sub package.

* Mon Jun 24 2002 Till Kamppeter <till@mandrakesoft.com> 0.9-0.3mdk
- Updated to current CVS.
- Separated off the xojpanel, so that the main package can easily be
  installed on an X-less server.

* Tue Jun 18 2002 Till Kamppeter <till@mandrakesoft.com> 0.9-0.2mdk
- Updated to current CVS
- Fixed setup for scanning (set links to scanner driver libraries, entry
  in /etc/sane.d/dll.conf)
- "ptal" backend for CUPS is in this package now
- Added "BuildRequires" line.

* Tue May 28 2002 Till Kamppeter <till@mandrakesoft.com> 0.9-0.1mdk
- Corrected path to QT 3 to make "xojpanel" getting compiled.
- Updated "allxojpanels" script.
- Bumped version number to 0.9.

* Tue May 28 2002 Till Kamppeter <till@mandrakesoft.com> 0.8-8mdk
- Updated to current CVS, version 0.8 is not compatible to gcc 3.1.
- Rebuilt for new libstdc++ and gcc 3.1.

* Sat Mar  2 2002 Till Kamppeter <till@mandrakesoft.com> 0.8-7mdk
- Fixed menu entry for "xojpanel", now a wrapper script searches for
  configured devices and starts "xojpanel" for these devices. 

* Fri Mar  1 2002 Till Kamppeter <till@mandrakesoft.com> 0.8-6mdk
- Patches for known problems from http://hpoj.sourceforge.net/todo.shtml
  (Patch2, Patch3)

* Wed Oct 24 2001 Vincent Saugey <vince@mandrakesoft.com> 0.8-5mdk
- Replace ucd-snmp require by libsnmp0

* Mon Oct 22 2001 Till Kamppeter <till@mandrakesoft.com> 0.8-4mdk
- Added patch to generate directories for the HPOJ daemons in the DevFS
  file system

* Sat Oct 20 2001 Stew Benedict <sbenedict@mandrakesoft.com> 0.8-3mdk
- patch for PPC build

* Wed Oct 10 2001 Till Kamppeter <till@mandrakesoft.com> 0.8-2mdk
- Rebuilt for libpng3.

* Wed Aug  8 2001 Till Kamppeter <till@mandrakesoft.com> 0.8-1mdk
- initial release
